#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-

"""
 @file AdditinalDataDBControl_idl_examplefile.py
 @brief Python example implementations generated from AdditinalDataDBControl.idl
 @date $Date$

 @author 別紙"機能仕様書_画像付加データDB制御RTC"参照

 New BSD

"""

import omniORB
from omniORB import CORBA, PortableServer
import AdditionalDBReqServ, AdditionalDBReqServ__POA
import AdditionalDBReqServ, AdditionalDBReqServ__POA
import AdditionalDBReqServ, AdditionalDBReqServ__POA
import AdditionalDBReqServ, AdditionalDBReqServ__POA
import AdditionalDBReqServ, AdditionalDBReqServ__POA
import AdditionalDBStsServ, AdditionalDBStsServ__POA

# ========== 共通 ==========
import VersatileOverheadSystem as imp_Versatile
import CommonPara as imp_CommPara


# ===================================================================
#     画像付加データDB登録要求 
# ===================================================================
class AddDBReqRegistAddData_i (AdditionalDBReqServ__POA.AddDBReqRegistAddData):
    """
    @class AddDBReqRegistAddData_i
    Example class implementing IDL interface AdditionalDBReqServ.AddDBReqRegistAddData
    """

    def __init__(self):
        """
        @brief standard constructor
        Initialise member variables here
        """
        #self._sFolderPath = imp_Versatile.FOLDER_PATH_INIT
        self.clrAddDBReqRegistAddData()

        pass

    # unsigned short usSetAddDBReqRegistAddData(in string sFolderPath)
    def usSetAddDBReqRegistAddData(self, sFolderPath):
        #raise CORBA.NO_IMPLEMENT(0, CORBA.COMPLETED_NO)
        # *** Implement me
        # Must return: result

        # ========== 範囲チェック ==========
        # ===== フォルダパス情報 =====
        if (sFolderPath != imp_Versatile.FOLDER_PATH_INIT and len(sFolderPath) <= (imp_Versatile.CSV_FOLDER_PATH_LENGTH + imp_Versatile.ROBOT_BASE_PATH_LENGTH)):
            # ===== チェックOK =====
            self._sFolderPath = sFolderPath
            return imp_Versatile.RESULT_ACK
        else:
            # ===== チェックNG =====
            print "[error]", "usSetAddDBReqRegistAddData NG", u"フォルダパス情報", sFolderPath 
            return imp_Versatile.RESULT_NACK
        
        print "[usSetAddDBReqRegistAddData] sFolderPath=",self._sFolderPath

     # string sGetAddDBReqRegistAddData()
    def GetAddDBReqRegistAddData(self):
        #raise CORBA.NO_IMPLEMENT(0, CORBA.COMPLETED_NO)
        # *** Implement me
        # Must return: result

        return (self._sFolderPath)

    # データクリア
    def clrAddDBReqRegistAddData(self):
        self._sFolderPath = imp_Versatile.FOLDER_PATH_INIT

        return


# ===================================================================           
#    撮影計画リスト作成要求
# ===================================================================
class AddDBReqMakeShootingPlanList_i (AdditionalDBReqServ__POA.AddDBReqMakeShootingPlanList):
    """
    @class AddDBReqMakeShootingPlanList_i
    Example class implementing IDL interface AdditionalDBReqServ.AddDBReqMakeShootingPlanList
    """

    def __init__(self):
        """
        @brief standard constructor
        Initialise member variables here
        """
        #self._ulRobotCategory = imp_Versatile.ROBOT_CATEGORY_INIT
        self.clrAddDBReqMakeShootingPlanList()

        pass

    # unsigned short usSetAddDBReqMakeShootingPlanList(in unsigned long ulRobotCategory)
    def usSetAddDBReqMakeShootingPlanList(self, ulRobotCategory):
        #raise CORBA.NO_IMPLEMENT(0, CORBA.COMPLETED_NO)
        # *** Implement me
        # Must return: result

        # ========== 範囲チェック ==========
        # ===== ロボットカテゴリー =====
        if (ulRobotCategory >= imp_Versatile.ROBOT_CATEGORY_DRONE and ulRobotCategory <= imp_Versatile.ROBOT_CATEGORY_MAX):
            # ===== チェックOK =====
            self._ulRobotCategory = ulRobotCategory
            return imp_Versatile.RESULT_ACK
        else:
            # ===== チェックNG =====
            print "[error]", "usSetAddDBReqMakeShootingPlanList NG" ,u"ロボットカテゴリー", ulRobotCategory
            return imp_Versatile.RESULT_NACK

    # unsigned long ulGetAddDBReqMakeShootingPlanList()
    def GetAddDBReqMakeShootingPlanList(self):
        #raise CORBA.NO_IMPLEMENT(0, CORBA.COMPLETED_NO)
        # *** Implement me
        # Must return: result
                   
        return (self._ulRobotCategory )

    # データクリア
    def clrAddDBReqMakeShootingPlanList(self):
        self._ulRobotCategory = imp_Versatile.ROBOT_CATEGORY_INIT
        
        return


# ===================================================================
#    撮影計画リスト取得要求 
# ===================================================================
class AddDBReqGetShootingPlanList_i (AdditionalDBReqServ__POA.AddDBReqGetShootingPlanList):
    """
    @class AddDBReqGetShootingPlanList_i
    Example class implementing IDL interface AdditionalDBReqServ.AddDBReqGetShootingPlanList
    """

    def __init__(self):
        """
        @brief standard constructor
        Initialise member variables here
        """
        #self._ulListReq = imp_Versatile.SERV_REQ_CLEAR
        self.clrAddDBReqGetShootingPlanList()

        pass

    # unsigned short usSetAddDBReqGetShootingPlanList(in unsigned long ulListReq)
    def usSetAddDBReqGetShootingPlanList(self, ulListReq):
        #raise CORBA.NO_IMPLEMENT(0, CORBA.COMPLETED_NO)
        # *** Implement me
        # Must return: result

        # ===== リスト要求 =====
        if (ulListReq >= imp_Versatile.SERV_REQ_CLEAR and ulListReq <= imp_Versatile.SERV_REQ_SET):
            self._ulListReq = ulListReq
            return imp_Versatile.RESULT_ACK
        else:
            # ===== チェックNG =====
            print "[error]", "usSetAddDBReqGetShootingPlanList NG" ,u"リスト要求", ulListReq
            return imp_Versatile.RESULT_NACK            

    # void GetAddDBReqGetShootingPlanList(out unsigned long ulListReq)
    def GetAddDBReqGetShootingPlanList(self):
        #raise CORBA.NO_IMPLEMENT(0, CORBA.COMPLETED_NO)
        # *** Implement me
        # Must return: ulListReq

        return (self._ulListReq )

    # データクリア
    def clrAddDBReqGetShootingPlanList(self):
        self._ulListReq = imp_Versatile.SERV_REQ_CLEAR

        return


# ===================================================================
#    座標指定画像付加データ取得要求 
# ===================================================================
class CoordinateDataGet_i (AdditionalDBReqServ__POA.CoordinateDataGet):
    """
    @class CoordinateDataGet_i
    Example class implementing IDL interface AdditionalDBReqServ.CoordinateDataGet
    """

    def __init__(self):
        """
        @brief standard constructor
        Initialise member variables here
        """
        self.clrCoordinateDataGet()

        pass

    # unsigned short usSetCoordinateDataGet(in unsigned long ulRobotCategory, in unsigned long ulGroupId, in double dStartLatitude, in double dStartLongitude, in double dEndLatitude, in double dEndLongitude)
    def usSetCoordinateDataGet(self, ulRobotCategory, ulGroupId, dStartLatitude, dStartLongitude, dEndLatitude, dEndLongitude):
        #raise CORBA.NO_IMPLEMENT(0, CORBA.COMPLETED_NO)
        # *** Implement me
        # Must return: result

        # ========= 範囲チェック ==========
        # ===== ロボットカテゴリー =====
        if (ulRobotCategory >= imp_Versatile.ROBOT_CATEGORY_DRONE and ulRobotCategory <= imp_Versatile.ROBOT_CATEGORY_MAX):
            self._ulRobotCategory = ulRobotCategory
        else:
            # ===== チェックNG =====
            print "[error]", "usSetCoordinateDataGet NG" ,u"ロボットカテゴリー", ulRobotCategory 
            return imp_Versatile.RESULT_NACK

        # ===== グループID =====        
        if str(ulGroupId).replace(".","").isdigit():
            self._ulGroupId = ulGroupId
        else:
            # ===== チェックNG =====
            print "[error]", "usSetCoordinateDataGet NG" ,u"グループID", ulGroupId 
            return imp_Versatile.RESULT_NACK

        # ===== 始点緯度 ====
        if ((str(dStartLatitude).replace(".","").isdigit()) and 
            (dStartLatitude >= imp_Versatile.LATITUBE_NIN and dStartLatitude <= imp_Versatile.LATITUBE_MAX)):
            self._dStartLatitude = dStartLatitude
        else:
            # ===== チェックNG =====
            print "[error]", "usSetCoordinateDataGet NG" ,u"始点緯度", dStartLatitude
            return imp_Versatile.RESULT_NACK

         # ===== 始点経度 ====
        if ((str(dStartLongitude).replace(".","").isdigit()) and 
            (dStartLongitude >= imp_Versatile.LONGITUDE_MIN and dStartLongitude <= imp_Versatile.LONGITUDE_MAX)):
            self._dStartLongitude = dStartLongitude
        else:
            # ===== チェックNG =====
            print "[error]", "usSetCoordinateDataGet NG" ,u"始点経度", dStartLongitude
            return imp_Versatile.RESULT_NACK

         # ===== 終点緯度 ====
        if ((str(dEndLatitude).replace(".","").isdigit()) and 
            (dEndLatitude >= imp_Versatile.LATITUBE_NIN and dEndLatitude <= imp_Versatile.LATITUBE_MAX)):
            self._dEndLatitude = dEndLatitude
        else:
            # ===== チェックNG =====
            print "[error]", "usSetCoordinateDataGet NG" ,u"終点緯度", dEndLatitude
            return imp_Versatile.RESULT_NACK

         # ===== 終点経度 ====
        if ((str(dEndLongitude).replace(".","").isdigit()) and 
            (dEndLongitude >= imp_Versatile.LONGITUDE_MIN and dEndLongitude <= imp_Versatile.LONGITUDE_MAX)):
            self._dEndLongitude = dEndLongitude
            return imp_Versatile.RESULT_ACK
        else:
            # ===== チェックNG =====
            print "[error]", "usSetCoordinateDataGet NG" ,u"終点経度", dEndLongitude
            return imp_Versatile.RESULT_NACK

    # void GetCoordinateDataGet(out unsigned long ulRobotCategory, out unsigned long ulGroupId, out double dStartPointCoordinate, out double dEndPointCoordinate)
    def GetCoordinateDataGet(self):
        #raise CORBA.NO_IMPLEMENT(0, CORBA.COMPLETED_NO)
        # *** Implement me
        # Must return: ulRobotCategory, ulGroupId, dStartLatitude, dStartLongitude, dEndLatitude, dEndLongitude

        return (self._ulRobotCategory, self._ulGroupId, self._dStartLatitude, self._dStartLongitude, self._dEndLatitude, self._dEndLongitude)

    # データクリア
    def clrCoordinateDataGet(self):
        self._ulRobotCategory = imp_Versatile.ROBOT_CATEGORY_INIT
        self._ulGroupId = imp_Versatile.GROUP_ID_NON
        self._dStartLatitude = 0
        self._dStartLongitude = 0
        self._dEndLatitude = 0
        self._dEndLongitude = 0

        return


# ===================================================================
#    撮影時刻順画像付加データ取得要求 
# ===================================================================
class ShootingTimeDateGet_i (AdditionalDBReqServ__POA.ShootingTimeDateGet):
    """
    @class ShootingTimeDateGet_i
    Example class implementing IDL interface AdditionalDBReqServ.ShootingTimeDateGet
    """

    def __init__(self):
        """
        @brief standard constructor
        Initialise member variables here
        """
        self.clrShootingTimeDateGet()

        pass

    # unsigned short usSetShootingTimeDateGet(in unsigned long ulRobotCategory, in unsigned long ulGroupId, in unsigned long ulImageAcq, in unsigned long ulReq)
    def usSetShootingTimeDateGet(self, ulRobotCategory, ulGroupId, ulImageAcq, ulReq):
        #raise CORBA.NO_IMPLEMENT(0, CORBA.COMPLETED_NO)
        # *** Implement me
        # Must return: result

        # ===== [START]の要求がこないて[UP],[DOWN]の要求があった場合はエラーとして、戻す =====
        if (imp_CommPara.SHOOTING_TIME_LAST_DATE == ""  or  imp_CommPara.SHOOTING_TIME_LAST_TIME == "" ):
            if (ulReq == imp_Versatile.SHOOTING_IMAGE_ACQ_UP or ulReq == imp_Versatile.SHOOTING_IMAGE_ACQ_DOWN):
                print ("[error]", "usSetShootingTimeDateGet NG" , u"画像要求区分", ulReq)
                return imp_Versatile.RESULT_NACK

        # ========== 範囲チェック ==========
        # ===== ロボットカテゴリー =====
        if (ulRobotCategory >= imp_Versatile.ROBOT_CATEGORY_DRONE and ulRobotCategory <= imp_Versatile.ROBOT_CATEGORY_MAX): 
            self._ulRobotCategory = ulRobotCategory
        else:
            # ===== チェックNG
            print "[error]", "usSetShootingTimeDateGet NG" , u"ロボットカテゴリー", ulRobotCategory
            return imp_Versatile.RESULT_NACK

        # ===== グループID =====
        if str(ulGroupId).replace(".","").isdigit():
            self._ulGroupId = ulGroupId
        else:
            # ===== チェックNG
            print "[error]", "usSetShootingTimeDateGet NG" ,u"グループID", ulGroupId
            return imp_Versatile.RESULT_NACK

        # ===== 画像取得区分 =====
        if (ulImageAcq >= imp_Versatile.SHOOTING_IMAGE_ACQ_STOP and ulImageAcq <= imp_Versatile.SHOOTING_IMAGE_ACQ_DOWN):
            self._ulImageAcq = ulImageAcq
        else:
            print "[error]", "usSetShootingTimeDateGet NG" ,u"画像取得区分", ulImageAcq
            return imp_Versatile.RESULT_NACK

        # ===== 要求有無 =====
        if (ulReq >= imp_Versatile.SERV_REQ_CLEAR and ulReq <= imp_Versatile.SERV_REQ_SET):
            self._ulReq = ulReq
            return imp_Versatile.RESULT_ACK
        else:
            print "[error]", "usSetShootingTimeDateGet NG" ,u"要求有無", ulImageAcq
            return imp_Versatile.RESULT_NACK

    # void GetShootingTimeDateGet(out unsigned long ulRobotCategory, out unsigned long ulGroupId, out unsigned long ulImageAcq, out unsigned long ulReq)
    def GetShootingTimeDateGet(self):
        #raise CORBA.NO_IMPLEMENT(0, CORBA.COMPLETED_NO)
        # *** Implement me
        # Must return: ulRobotCategory, ulGroupId, ulImageAcq, ulReq

        return (self._ulRobotCategory, self._ulGroupId, self._ulImageAcq, self._ulReq)

    # データクリア
    def clrShootingTimeDateGet(self):
        self._ulRobotCategory = imp_Versatile.ROBOT_CATEGORY_INIT
        self._ulGroupId = imp_Versatile.GROUP_ID_NON
        self._ulImageAcq = imp_Versatile.SHOOTING_IMAGE_ACQ_STOP
        self._ulReq = imp_Versatile.SERV_REQ_CLEAR

        return


# ===================================================================
#    画像付加データＤＢ制御 完了通知
# ===================================================================
class AddDBNotice_i (AdditionalDBStsServ__POA.AddDBNotice):
    """
    @class AddDBNotice_i
    Example class implementing IDL interface AdditionalDBStsServ.AddDBNotice
    """

    def __init__(self):
        """
        @brief standard constructor
        Initialise member variables here
        """
#         self._ulNotice = imp_Versatile.NOTICE_INIT
#         self._ulParam = imp_Versatile.NOTICE_PARAM_INIT
        self.clrAddDBNotice()

        pass

    # unsigned short usSetAddDBNotice(in unsigned long ulNotice, in unsigned long ulParam)
    def usSetAddDBNotice(self, ulNotice, ulParam):
        #raise CORBA.NO_IMPLEMENT(0, CORBA.COMPLETED_NO)
        # *** Implement me
        # Must return: result

        self._ulNotice = ulNotice
        self._ulParam = ulParam
        return imp_Versatile.RESULT_ACK

        # ========== 範囲チェック ==========
#         if ulNotice.isnumeric():
#             if (ulNotice >= imp_Versatile.ADD_DB_NOTICE_REGIST_SUCCESS and ulNotice <= imp_Versatile.ADD_DB_NOTICE_MAX):
#                  # ===== チェックOK =====
#                 self._ulNotice = ulNotice
#             else:
#                 # ===== チェックOK =====
#                 print ("[error]", "usSetAddDBNotice NG" , ulNotice)
#                 return imp_Versatile.RESULT_NACK

    # void GetAddDBNotice(out unsigned long ulNotice, out unsigned long ulParam)
    def GetAddDBNotice(self):
        #raise CORBA.NO_IMPLEMENT(0, CORBA.COMPLETED_NO)
        # *** Implement me
        # Must return: ulNotice, ulParam
        
        return (self._ulNotice,self._ulParam)

    # データクリア
    def clrAddDBNotice(self):
        self._ulNotice = imp_Versatile.NOTICE_INIT
        self._ulParam = imp_Versatile.NOTICE_PARAM_INIT
        
        return



if __name__ == "__main__":
    import sys
    
    # Initialise the ORB
    orb = CORBA.ORB_init(sys.argv)
    
    # As an example, we activate an object in the Root POA
    poa = orb.resolve_initial_references("RootPOA")

    # Create an instance of a servant class
    servant = AddDBReqRegistAddData_i()

    # Activate it in the Root POA
    poa.activate_object(servant)

    # Get the object reference to the object
    objref = servant._this()
    
    # Print a stringified IOR for it
    print orb.object_to_string(objref)

    # Activate the Root POA's manager
    poa._get_the_POAManager().activate()

    # Run the ORB, blocking this thread
    orb.run()

